io.etcd.jetcd

## Interface Auth

All Superinterfaces:
  AutoCloseable, CloseableClient

    public interface Auth
    extends CloseableClient

Interface of auth talking to etcd.

### Method Summary

All Methods Instance Methods Abstract Methods
`CompletableFuture<AuthDisableResponse>` `authDisable()` disables auth of an etcd cluster.
`CompletableFuture<AuthEnableResponse>` `authEnable()` enables auth of an etcd cluster.
`CompletableFuture<AuthRoleAddResponse>` `roleAdd(ByteSequence user)` adds a new role to an etcd cluster.
`CompletableFuture<AuthRoleDeleteResponse>` `roleDelete(ByteSequence role)` RoleDelete deletes a role.
`CompletableFuture<AuthRoleGetResponse>` `roleGet(ByteSequence role)` gets a detailed information of a role.
`CompletableFuture<AuthRoleGrantPermissionResponse>` `roleGrantPermission(ByteSequence role, ByteSequence key, ByteSequence rangeEnd, Permission.Type permType)` grants a permission to a role.
`CompletableFuture<AuthRoleListResponse>` `roleList()` gets a list of all roles.
`CompletableFuture<AuthRoleRevokePermissionResponse>` `roleRevokePermission(ByteSequence role, ByteSequence key, ByteSequence rangeEnd)` revokes a permission from a role.
`CompletableFuture<AuthUserAddResponse>` `userAdd(ByteSequence user, ByteSequence password)` adds a new user to an etcd cluster.
`CompletableFuture<AuthUserChangePasswordResponse>` `userChangePassword(ByteSequence user, ByteSequence password)` changes a password of a user.
`CompletableFuture<AuthUserDeleteResponse>` `userDelete(ByteSequence user)` deletes a user from an etcd cluster.
`CompletableFuture<AuthUserGetResponse>` `userGet(ByteSequence user)` gets a detailed information of a user.
`CompletableFuture<AuthUserGrantRoleResponse>` `userGrantRole(ByteSequence user, ByteSequence role)` grants a role to a user.
`CompletableFuture<AuthUserListResponse>` `userList()` gets a list of all users.
`CompletableFuture<AuthUserRevokeRoleResponse>` `userRevokeRole(ByteSequence user, ByteSequence role)` revokes a role of a user.

### Methods inherited from interface io.etcd.jetcd.CloseableClient

`close`

### Method Detail

#### authEnable

    CompletableFuture<AuthEnableResponse> authEnable()

enables auth of an etcd cluster.

#### authDisable

    CompletableFuture<AuthDisableResponse> authDisable()

disables auth of an etcd cluster.

#### userAdd

    CompletableFuture<AuthUserAddResponse> userAdd(ByteSequence user,
                                                   ByteSequence password)

adds a new user to an etcd cluster.

#### userDelete

    CompletableFuture<AuthUserDeleteResponse> userDelete(ByteSequence user)

deletes a user from an etcd cluster.

#### userChangePassword

    CompletableFuture<AuthUserChangePasswordResponse> userChangePassword(ByteSequence user,
                                                                         ByteSequence password)

changes a password of a user.

#### userGet

    CompletableFuture<AuthUserGetResponse> userGet(ByteSequence user)

gets a detailed information of a user.

#### userList

    CompletableFuture<AuthUserListResponse> userList()

gets a list of all users.

#### userGrantRole

    CompletableFuture<AuthUserGrantRoleResponse> userGrantRole(ByteSequence user,
                                                               ByteSequence role)

grants a role to a user.

#### userRevokeRole

    CompletableFuture<AuthUserRevokeRoleResponse> userRevokeRole(ByteSequence user,
                                                                 ByteSequence role)

revokes a role of a user.

#### roleAdd

    CompletableFuture<AuthRoleAddResponse> roleAdd(ByteSequence user)

adds a new role to an etcd cluster.

#### roleGrantPermission

    CompletableFuture<AuthRoleGrantPermissionResponse> roleGrantPermission(ByteSequence role,
                                                                           ByteSequence key,
                                                                           ByteSequence rangeEnd,
                                                                           Permission.Type permType)

grants a permission to a role.

#### roleGet

    CompletableFuture<AuthRoleGetResponse> roleGet(ByteSequence role)

gets a detailed information of a role.

#### roleList

    CompletableFuture<AuthRoleListResponse> roleList()

gets a list of all roles.

#### roleRevokePermission

    CompletableFuture<AuthRoleRevokePermissionResponse> roleRevokePermission(ByteSequence role,
                                                                             ByteSequence key,
                                                                             ByteSequence rangeEnd)

revokes a permission from a role.

#### roleDelete

    CompletableFuture<AuthRoleDeleteResponse> roleDelete(ByteSequence role)

RoleDelete deletes a role.